searchNodes=[{"doc":"OPC UA Client API module. This module provides functions for configuration, read/write nodes attributes and discovery of a OPC UA Client. OpcUA.Client is implemented as a __using__ macro so that you can put it in any module, you can initialize your Client manually (see test/client_tests ) or by overwriting configuration/1 and monitored_items/1 to autoset the configuration and subscription items. It also helps you to handle Client's &quot;subscription&quot; events (monitorItems) by overwriting handle_subscription/2 callback. The following example shows a module that takes its configuration from the environment (see test/client_tests/terraform_test.exs ): defmodule MyClient do use OpcUA.Client # Use the `init` function to configure your Client. def init ( { parent_pid , 103 } = _user_init_state , opc_ua_client_pid ) do %{ parent_pid : parent_pid , opc_ua_client_pid : opc_ua_client_pid } end def configuration ( _user_init_state ) , do : Application . get_env ( :my_client , :configuration , [ ] ) def monitored_items ( _user_init_state ) , do : Application . get_env ( :my_client , :monitored_items , [ ] ) def handle_subscription_timeout ( subscription_id , state ) do send ( state . parent_pid , { :subscription_timeout , subscription_id } ) state end def handle_deleted_subscription ( subscription_id , state ) do send ( state . parent_pid , { :subscription_delete , subscription_id } ) state end def handle_monitored_data ( changed_data_event , state ) do send ( state . parent_pid , { :value_changed , changed_data_event } ) state end def handle_deleted_monitored_item ( subscription_id , monitored_id , state ) do send ( state . parent_pid , { :item_deleted , { subscription_id , monitored_id } } ) state end end Because it is small a GenServer, it accepts the same options for supervision to configure the child spec and passes them along to GenServer : defmodule MyModule do use OpcUA.Client , restart : :transient , shutdown : 10_000 end","ref":"OpcUA.Client.html","title":"OpcUA.Client","type":"behaviour"},{"doc":"Adds a monitored item used to request a server for notifications of each change of value in a specific node. The following option must be filled: :subscription_id -&gt; integer(). :monitored_item -&gt; %NodeId{}.","ref":"OpcUA.Client.html#add_monitored_item/2","title":"OpcUA.Client.add_monitored_item/2","type":"function"},{"doc":"Sends an OPC UA Server request to start subscription (to monitored items, events, etc).","ref":"OpcUA.Client.html#add_subscription/2","title":"OpcUA.Client.add_subscription/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"OpcUA.Client.html#child_spec/1","title":"OpcUA.Client.child_spec/1","type":"function"},{"doc":"Optional callback that gets the Server configuration and discovery connection parameters.","ref":"OpcUA.Client.html#c:configuration/1","title":"OpcUA.Client.configuration/1","type":"callback"},{"doc":"Connects the OPC UA Client by a url. The following must be filled: :url -&gt; binary().","ref":"OpcUA.Client.html#connect_by_url/2","title":"OpcUA.Client.connect_by_url/2","type":"function"},{"doc":"Connects the OPC UA Client by a url using a username and a password. The following must be filled: :url -&gt; binary(). :user -&gt; binary(). :password -&gt; binary().","ref":"OpcUA.Client.html#connect_by_username/2","title":"OpcUA.Client.connect_by_username/2","type":"function"},{"doc":"Connects the OPC UA Client by a url without a session. The following must be filled: :url -&gt; binary().","ref":"OpcUA.Client.html#connect_no_session/2","title":"OpcUA.Client.connect_no_session/2","type":"function"},{"doc":"Adds a monitored item used to request a server for notifications of each change of value in a specific node. The following option must be filled: :subscription_id -&gt; integer(). :monitored_item_id -&gt; integer().","ref":"OpcUA.Client.html#delete_monitored_item/2","title":"OpcUA.Client.delete_monitored_item/2","type":"function"},{"doc":"Sends an OPC UA Server request to delete a subscription.","ref":"OpcUA.Client.html#delete_subscription/2","title":"OpcUA.Client.delete_subscription/2","type":"function"},{"doc":"Disconnects the OPC UA Client.","ref":"OpcUA.Client.html#disconnect/1","title":"OpcUA.Client.disconnect/1","type":"function"},{"doc":"Finds Servers Connected to a Discovery Server. The following must be filled: :url -&gt; binary().","ref":"OpcUA.Client.html#find_servers/2","title":"OpcUA.Client.find_servers/2","type":"function"},{"doc":"Finds Servers Connected to a Discovery Server. The following must be filled: :url -&gt; binary().","ref":"OpcUA.Client.html#find_servers_on_network/2","title":"OpcUA.Client.find_servers_on_network/2","type":"function"},{"doc":"Gets the OPC UA Client current Configuration.","ref":"OpcUA.Client.html#get_config/1","title":"OpcUA.Client.get_config/1","type":"function"},{"doc":"Get endpoints from a OPC UA Server. The following must be filled: :url -&gt; binary().","ref":"OpcUA.Client.html#get_endpoints/2","title":"OpcUA.Client.get_endpoints/2","type":"function"},{"doc":"Gets the state of the OPC UA Client.","ref":"OpcUA.Client.html#get_state/1","title":"OpcUA.Client.get_state/1","type":"function"},{"doc":"Optional callback that handles a deleted monitored items events. It's first argument is the subscription_id of the subscription that the monitored item belongs to. The second element is the 'monitored_item_id' which is an unique number asigned to a monitored item when its created. The third argument it's the GenServer state (Parent process).","ref":"OpcUA.Client.html#c:handle_deleted_monitored_item/3","title":"OpcUA.Client.handle_deleted_monitored_item/3","type":"callback"},{"doc":"Optional callback that handles a subscriptions timeout events. It's first argument is the subscription_id of the subscription. The second argument it's the GenServer state (Parent process).","ref":"OpcUA.Client.html#c:handle_deleted_subscription/2","title":"OpcUA.Client.handle_deleted_subscription/2","type":"callback"},{"doc":"Optional callback that handles node values updates from a Client to a Server. It's first argument is a tuple, in which its first element is the subscription_id of the subscription that the monitored item belongs to. the second element is the 'monitored_item_id' which is an unique number asigned to a monitored item when its created and the third element of the tuple is the new value of the monitored item. the second argument it's the GenServer state (Parent process).","ref":"OpcUA.Client.html#c:handle_monitored_data/2","title":"OpcUA.Client.handle_monitored_data/2","type":"callback"},{"doc":"Optional callback that handles a subscriptions timeout events. It's first argument is the subscription_id of the subscription. The second argument it's the GenServer state (Parent process).","ref":"OpcUA.Client.html#c:handle_subscription_timeout/2","title":"OpcUA.Client.handle_subscription_timeout/2","type":"callback"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"OpcUA.Client.html#init/1","title":"OpcUA.Client.init/1","type":"function"},{"doc":"","ref":"OpcUA.Client.html#c:monitored_items/1","title":"OpcUA.Client.monitored_items/1","type":"callback"},{"doc":"Reads 'Access level' of a node in the server.","ref":"OpcUA.Client.html#read_node_access_level/2","title":"OpcUA.Client.read_node_access_level/2","type":"function"},{"doc":"Reads 'array_dimensions' of a node in the server.","ref":"OpcUA.Client.html#read_node_array_dimensions/2","title":"OpcUA.Client.read_node_array_dimensions/2","type":"function"},{"doc":"Reads the browse name attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_browse_name/2","title":"OpcUA.Client.read_node_browse_name/2","type":"function"},{"doc":"Reads 'contains_no_loops' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_contains_no_loops/2","title":"OpcUA.Client.read_node_contains_no_loops/2","type":"function"},{"doc":"Reads 'data_type' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_data_type/2","title":"OpcUA.Client.read_node_data_type/2","type":"function"},{"doc":"Reads description attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_description/2","title":"OpcUA.Client.read_node_description/2","type":"function"},{"doc":"Reads the display name attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_display_name/2","title":"OpcUA.Client.read_node_display_name/2","type":"function"},{"doc":"Reads 'event_notifier' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_event_notifier/2","title":"OpcUA.Client.read_node_event_notifier/2","type":"function"},{"doc":"Reads 'Executable' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_executable/2","title":"OpcUA.Client.read_node_executable/2","type":"function"},{"doc":"Reads 'Historizing' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_historizing/2","title":"OpcUA.Client.read_node_historizing/2","type":"function"},{"doc":"Reads 'Inverse name' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_inverse_name/2","title":"OpcUA.Client.read_node_inverse_name/2","type":"function"},{"doc":"Reads 'Is Abstract' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_is_abstract/2","title":"OpcUA.Client.read_node_is_abstract/2","type":"function"},{"doc":"Reads 'Minimum Sampling Interval level' of a node in the server.","ref":"OpcUA.Client.html#read_node_minimum_sampling_interval/2","title":"OpcUA.Client.read_node_minimum_sampling_interval/2","type":"function"},{"doc":"Reads the node_class attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_node_class/2","title":"OpcUA.Client.read_node_node_class/2","type":"function"},{"doc":"Reads the node_id attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_node_id/2","title":"OpcUA.Client.read_node_node_id/2","type":"function"},{"doc":"Reads 'Symmetric' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_symmetric/2","title":"OpcUA.Client.read_node_symmetric/2","type":"function"},{"doc":"Reads 'user_access_level' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_user_access_level/2","title":"OpcUA.Client.read_node_user_access_level/2","type":"function"},{"doc":"Reads 'user_executable' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_user_executable/2","title":"OpcUA.Client.read_node_user_executable/2","type":"function"},{"doc":"Reads 'user_write_mask' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_user_write_mask/2","title":"OpcUA.Client.read_node_user_write_mask/2","type":"function"},{"doc":"Reads 'value' attribute of a node in the server. Note: If the value is an array you can search a scalar using index parameter.","ref":"OpcUA.Client.html#read_node_value/3","title":"OpcUA.Client.read_node_value/3","type":"function"},{"doc":"Reads 'Value' attribute (matching data type) of a node in the server.","ref":"OpcUA.Client.html#read_node_value_by_data_type/3","title":"OpcUA.Client.read_node_value_by_data_type/3","type":"function"},{"doc":"Reads 'value' attribute of a node in the server. Note: If the value is an array you can search a scalar using index parameter.","ref":"OpcUA.Client.html#read_node_value_by_index/3","title":"OpcUA.Client.read_node_value_by_index/3","type":"function"},{"doc":"Reads 'Value Rank' of a node in the server.","ref":"OpcUA.Client.html#read_node_value_rank/2","title":"OpcUA.Client.read_node_value_rank/2","type":"function"},{"doc":"Reads 'Write Mask' attribute of a node in the server.","ref":"OpcUA.Client.html#read_node_write_mask/2","title":"OpcUA.Client.read_node_write_mask/2","type":"function"},{"doc":"Resets the OPC UA Client.","ref":"OpcUA.Client.html#reset/1","title":"OpcUA.Client.reset/1","type":"function"},{"doc":"Sets the OPC UA Client configuration.","ref":"OpcUA.Client.html#set_config/2","title":"OpcUA.Client.set_config/2","type":"function"},{"doc":"Sets the OPC UA Client configuration with all security policies for the given certificates. The following must be filled: * ` :private_key ` -&gt; binary ( ) or function ( ) . * ` :certificate ` -&gt; binary ( ) or function ( ) . * ` :security_mode ` -&gt; interger ( ) . NOTE: [none: 1, sign: 2, sign_and_encrypt: 3]","ref":"OpcUA.Client.html#set_config_with_certs/2","title":"OpcUA.Client.set_config_with_certs/2","type":"function"},{"doc":"Starts up a OPC UA Client GenServer.","ref":"OpcUA.Client.html#start_link/2","title":"OpcUA.Client.start_link/2","type":"function"},{"doc":"Stops a OPC UA Client GenServer.","ref":"OpcUA.Client.html#stop/1","title":"OpcUA.Client.stop/1","type":"function"},{"doc":"Change 'Access level' of a node in the server.","ref":"OpcUA.Client.html#write_node_access_level/3","title":"OpcUA.Client.write_node_access_level/3","type":"function"},{"doc":"Change 'Array Dimensions' of a node in the server.","ref":"OpcUA.Client.html#write_node_array_dimensions/3","title":"OpcUA.Client.write_node_array_dimensions/3","type":"function"},{"doc":"Creates a blank 'value array' attribute of a node in the server. Note: the array must match with 'value_rank' and 'array_dimensions' attribute.","ref":"OpcUA.Client.html#write_node_blank_array/4","title":"OpcUA.Client.write_node_blank_array/4","type":"function"},{"doc":"Change the browse name of a node in the server.","ref":"OpcUA.Client.html#write_node_browse_name/3","title":"OpcUA.Client.write_node_browse_name/3","type":"function"},{"doc":"Change 'contains_no_loops' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_contains_no_loops/3","title":"OpcUA.Client.write_node_contains_no_loops/3","type":"function"},{"doc":"Change 'data_type' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_data_type/3","title":"OpcUA.Client.write_node_data_type/3","type":"function"},{"doc":"Change description attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_description/4","title":"OpcUA.Client.write_node_description/4","type":"function"},{"doc":"Change the display name attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_display_name/4","title":"OpcUA.Client.write_node_display_name/4","type":"function"},{"doc":"Change 'event_notifier' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_event_notifier/3","title":"OpcUA.Client.write_node_event_notifier/3","type":"function"},{"doc":"Change 'Executable' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_executable/3","title":"OpcUA.Client.write_node_executable/3","type":"function"},{"doc":"Change 'Historizing' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_historizing/3","title":"OpcUA.Client.write_node_historizing/3","type":"function"},{"doc":"Change 'Inverse name' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_inverse_name/4","title":"OpcUA.Client.write_node_inverse_name/4","type":"function"},{"doc":"Change 'Is Abstract' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_is_abstract/3","title":"OpcUA.Client.write_node_is_abstract/3","type":"function"},{"doc":"Change 'Minimum Sampling Interval level' of a node in the server.","ref":"OpcUA.Client.html#write_node_minimum_sampling_interval/3","title":"OpcUA.Client.write_node_minimum_sampling_interval/3","type":"function"},{"doc":"Change 'node_class' attribute of a node in the server. Avalable value are: UNSPECIFIED = 0 , OBJECT = 1 , VARIABLE = 2 , METHOD = 4 , OBJECTTYPE = 8 , VARIABLETYPE = 16 , REFERENCETYPE = 32 , DATATYPE = 64 , VIEW = 128 ,","ref":"OpcUA.Client.html#write_node_node_class/3","title":"OpcUA.Client.write_node_node_class/3","type":"function"},{"doc":"Change 'node_id' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_node_id/3","title":"OpcUA.Client.write_node_node_id/3","type":"function"},{"doc":"Change 'symmetric' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_symmetric/3","title":"OpcUA.Client.write_node_symmetric/3","type":"function"},{"doc":"Change 'user_access_level' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_user_access_level/3","title":"OpcUA.Client.write_node_user_access_level/3","type":"function"},{"doc":"Change 'user_executable' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_user_executable/3","title":"OpcUA.Client.write_node_user_executable/3","type":"function"},{"doc":"Change 'user_write_mask' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_user_write_mask/3","title":"OpcUA.Client.write_node_user_write_mask/3","type":"function"},{"doc":"Change 'Value' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_value/5","title":"OpcUA.Client.write_node_value/5","type":"function"},{"doc":"Change 'Value rank' of a node in the server. This attribute indicates whether the value attribute of the variable is an array and how many dimensions the array has. It may have the following values: value_rank &gt;= 1: the value is an array with the specified number of dimensions value_rank = 0: the value is an array with one or more dimensions value_rank = -1: the value is a scalar value_rank = -2: the value can be a scalar or an array with any number of dimensions value_rank = -3: the value can be a scalar or a one dimensional array","ref":"OpcUA.Client.html#write_node_value_rank/3","title":"OpcUA.Client.write_node_value_rank/3","type":"function"},{"doc":"Change 'Write Mask' attribute of a node in the server.","ref":"OpcUA.Client.html#write_node_write_mask/3","title":"OpcUA.Client.write_node_write_mask/3","type":"function"},{"doc":"","ref":"OpcUA.Client.html#t:config_options/0","title":"OpcUA.Client.config_options/0","type":"type"},{"doc":"","ref":"OpcUA.Client.html#t:conn_params/0","title":"OpcUA.Client.conn_params/0","type":"type"},{"doc":"","ref":"OpcUA.Client.html#t:monitored_items_options/0","title":"OpcUA.Client.monitored_items_options/0","type":"type"},{"doc":"This module covers common functions for Client &amp; Server behavior.","ref":"OpcUA.Common.html","title":"OpcUA.Common","type":"module"},{"doc":"OPC UA Server API module. This module provides functions for configuration, add/delete/read/write nodes and discovery a OPC UA Server. OpcUA.Server is implemented as a __using__ macro so that you can put it in any module, you can initialize your Server manually (see test/server_tests/write_event_test.exs ) or by overwriting configuration/1 and address_space/1 to autoset the configuration and information model. It also helps you to handle Server's &quot;write value&quot; events by overwriting handle_write/2 callback. The following example shows a module that takes its configuration from the environment (see test/server_tests/terraform_test.exs ): defmodule MyServer do use OpcUA.Server alias OpcUA.Server # Use the `init` function to configure your server. def init ( { parent_pid , 103 } = _user_init_state , opc_ua_server_pid ) do Server . start ( opc_ua_server_pid ) %{ parent_pid : parent_pid } end def configuration ( _user_init_state ) , do : Application . get_env ( :opex62541 , :configuration , [ ] ) def address_space ( _user_init_state ) , do : Application . get_env ( :opex62541 , :address_space , [ ] ) def handle_write ( write_event , %{ parent_pid : parent_pid } = state ) do send ( parent_pid , write_event ) state end end Because it is small a GenServer, it accepts the same options for supervision to configure the child spec and passes them along to GenServer : defmodule MyModule do use OpcUA.Server , restart : :transient , shutdown : 10_000 end","ref":"OpcUA.Server.html","title":"OpcUA.Server","type":"behaviour"},{"doc":"Adds endpoints for all configured security policies in each mode.","ref":"OpcUA.Server.html#add_all_endpoints/1","title":"OpcUA.Server.add_all_endpoints/1","type":"function"},{"doc":"Adds all supported security policies and sets up certificate validation procedures (no endpoint). The following must be filled: :private_key -&gt; binary() or function(). :certificate -&gt; binary() or function().","ref":"OpcUA.Server.html#add_all_policies/2","title":"OpcUA.Server.add_all_policies/2","type":"function"},{"doc":"Adds the security policy SecurityPolicy#Basic128Rsa15 to the server with certicate (no endpoint). The following must be filled: :private_key -&gt; binary() or function(). :certificate -&gt; binary() or function().","ref":"OpcUA.Server.html#add_basic128rsa15_policy/2","title":"OpcUA.Server.add_basic128rsa15_policy/2","type":"function"},{"doc":"Adds the security policy SecurityPolicy#Basic256 to the server with certicate (no endpoint). The following must be filled: :private_key -&gt; binary() or function(). :certificate -&gt; binary() or function().","ref":"OpcUA.Server.html#add_basic256_policy/2","title":"OpcUA.Server.add_basic256_policy/2","type":"function"},{"doc":"Adds the security policy SecurityPolicy#Basic256Sha256 to the server with certicate (no endpoint). The following must be filled: :private_key -&gt; binary() or function(). :certificate -&gt; binary() or function().","ref":"OpcUA.Server.html#add_basic256sha256_policy/2","title":"OpcUA.Server.add_basic256sha256_policy/2","type":"function"},{"doc":"Add a new data type node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}.","ref":"OpcUA.Server.html#add_data_type_node/2","title":"OpcUA.Server.add_data_type_node/2","type":"function"},{"doc":"Create a local MonitoredItem with a sampling interval that detects data changes. The following must be filled: :monitored_item -&gt; %NodeID{}. :sampling_time -&gt; double().","ref":"OpcUA.Server.html#add_monitored_item/2","title":"OpcUA.Server.add_monitored_item/2","type":"function"},{"doc":"Add a new namespace.","ref":"OpcUA.Server.html#add_namespace/2","title":"OpcUA.Server.add_namespace/2","type":"function"},{"doc":"Adds the security policy SecurityPolicy#None to the server with certicate (no endpoint). The following must be filled: :certificate -&gt; binary() or function().","ref":"OpcUA.Server.html#add_none_policy/2","title":"OpcUA.Server.add_none_policy/2","type":"function"},{"doc":"Add a new object node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}. :type_definition -&gt; %NodeID{}.","ref":"OpcUA.Server.html#add_object_node/2","title":"OpcUA.Server.add_object_node/2","type":"function"},{"doc":"Add a new object type node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}.","ref":"OpcUA.Server.html#add_object_type_node/2","title":"OpcUA.Server.add_object_type_node/2","type":"function"},{"doc":"Add a new reference in the server. The following must be filled: :source_id -&gt; %NodeID{}. :reference_type_id -&gt; %NodeID{}. :target_id -&gt; %NodeID{}. :is_forward -&gt; boolean().","ref":"OpcUA.Server.html#add_reference/2","title":"OpcUA.Server.add_reference/2","type":"function"},{"doc":"Add a new reference type node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}.","ref":"OpcUA.Server.html#add_reference_type_node/2","title":"OpcUA.Server.add_reference_type_node/2","type":"function"},{"doc":"Add a new variable node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}. :type_definition -&gt; %NodeID{}.","ref":"OpcUA.Server.html#add_variable_node/2","title":"OpcUA.Server.add_variable_node/2","type":"function"},{"doc":"Add a new variable type node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}. :type_definition -&gt; %NodeID{}.","ref":"OpcUA.Server.html#add_variable_type_node/2","title":"OpcUA.Server.add_variable_type_node/2","type":"function"},{"doc":"Add a new view node to the server. The following must be filled: :requested_new_node_id -&gt; %NodeID{}. :parent_node_id -&gt; %NodeID{}. :reference_type_node_id -&gt; %NodeID{}. :browse_name -&gt; %QualifiedName{}.","ref":"OpcUA.Server.html#add_view_node/2","title":"OpcUA.Server.add_view_node/2","type":"function"},{"doc":"Optional callback that gets a list of nodes (with their attributes) to be automatically set.","ref":"OpcUA.Server.html#c:address_space/1","title":"OpcUA.Server.address_space/1","type":"callback"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"OpcUA.Server.html#child_spec/1","title":"OpcUA.Server.child_spec/1","type":"function"},{"doc":"Optional callback that gets the Server configuration and discovery connection parameters.","ref":"OpcUA.Server.html#c:configuration/1","title":"OpcUA.Server.configuration/1","type":"callback"},{"doc":"Deletes a local MonitoredItem.","ref":"OpcUA.Server.html#delete_monitored_item/2","title":"OpcUA.Server.delete_monitored_item/2","type":"function"},{"doc":"Deletes a node in the server. The following must be filled: :node_id -&gt; %NodeID{}. :delete_references -&gt; boolean().","ref":"OpcUA.Server.html#delete_node/2","title":"OpcUA.Server.delete_node/2","type":"function"},{"doc":"Deletes a reference in the server. The following must be filled: :source_id -&gt; %NodeID{}. :reference_type_id -&gt; %NodeID{}. :target_id -&gt; %NodeID{}. :is_forward -&gt; boolean(). :delete_bidirectional -&gt; boolean().","ref":"OpcUA.Server.html#delete_reference/2","title":"OpcUA.Server.delete_reference/2","type":"function"},{"doc":"Registers a server in a discovery server. NOTE: The Server sends the request once started. Use port = 0 to dynamically port allocation. The following must be filled: :application_uri -&gt; binary(). :server_name -&gt; binary(). :endpoint -&gt; binary(). :timeout -&gt; boolean().","ref":"OpcUA.Server.html#discovery_register/2","title":"OpcUA.Server.discovery_register/2","type":"function"},{"doc":"Unregister the server from the discovery server. NOTE: Server must be started.","ref":"OpcUA.Server.html#discovery_unregister/1","title":"OpcUA.Server.discovery_unregister/1","type":"function"},{"doc":"Reads an internal Server Config.","ref":"OpcUA.Server.html#get_config/1","title":"OpcUA.Server.get_config/1","type":"function"},{"doc":"Optional callback that handles node values updates from a Client to a Server. It's first argument will a tuple, in which its first element is the node_id of the updated node and the second element is the updated value. the second argument it's the GenServer state (Parent process).","ref":"OpcUA.Server.html#c:handle_write/2","title":"OpcUA.Server.handle_write/2","type":"callback"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"OpcUA.Server.html#init/1","title":"OpcUA.Server.init/1","type":"function"},{"doc":"Reads 'Access level' of a node in the server.","ref":"OpcUA.Server.html#read_node_access_level/2","title":"OpcUA.Server.read_node_access_level/2","type":"function"},{"doc":"Reads 'array_dimensions' of a node in the server.","ref":"OpcUA.Server.html#read_node_array_dimensions/2","title":"OpcUA.Server.read_node_array_dimensions/2","type":"function"},{"doc":"Reads the browse name attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_browse_name/2","title":"OpcUA.Server.read_node_browse_name/2","type":"function"},{"doc":"Reads 'contains_no_loops' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_contains_no_loops/2","title":"OpcUA.Server.read_node_contains_no_loops/2","type":"function"},{"doc":"Reads 'data_type' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_data_type/2","title":"OpcUA.Server.read_node_data_type/2","type":"function"},{"doc":"Reads description attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_description/2","title":"OpcUA.Server.read_node_description/2","type":"function"},{"doc":"Reads the display name attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_display_name/2","title":"OpcUA.Server.read_node_display_name/2","type":"function"},{"doc":"Reads 'event_notifier' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_event_notifier/2","title":"OpcUA.Server.read_node_event_notifier/2","type":"function"},{"doc":"Reads 'Executable' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_executable/2","title":"OpcUA.Server.read_node_executable/2","type":"function"},{"doc":"Reads 'Historizing' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_historizing/2","title":"OpcUA.Server.read_node_historizing/2","type":"function"},{"doc":"Reads 'Inverse name' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_inverse_name/2","title":"OpcUA.Server.read_node_inverse_name/2","type":"function"},{"doc":"Reads 'Is Abstract' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_is_abstract/2","title":"OpcUA.Server.read_node_is_abstract/2","type":"function"},{"doc":"Reads 'Minimum Sampling Interval level' of a node in the server.","ref":"OpcUA.Server.html#read_node_minimum_sampling_interval/2","title":"OpcUA.Server.read_node_minimum_sampling_interval/2","type":"function"},{"doc":"Reads the node_class attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_node_class/2","title":"OpcUA.Server.read_node_node_class/2","type":"function"},{"doc":"Reads the node_id attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_node_id/2","title":"OpcUA.Server.read_node_node_id/2","type":"function"},{"doc":"Reads 'Symmetric' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_symmetric/2","title":"OpcUA.Server.read_node_symmetric/2","type":"function"},{"doc":"Reads 'value' attribute of a node in the server. Note: If the value is an array you can search a scalar using index parameter.","ref":"OpcUA.Server.html#read_node_value/3","title":"OpcUA.Server.read_node_value/3","type":"function"},{"doc":"Reads 'Value' attribute (matching data type) of a node in the server.","ref":"OpcUA.Server.html#read_node_value_by_data_type/3","title":"OpcUA.Server.read_node_value_by_data_type/3","type":"function"},{"doc":"Reads 'value' attribute of a node in the server. Note: If the value is an array you can search a scalar using index parameter.","ref":"OpcUA.Server.html#read_node_value_by_index/3","title":"OpcUA.Server.read_node_value_by_index/3","type":"function"},{"doc":"Reads 'Value Rank' of a node in the server.","ref":"OpcUA.Server.html#read_node_value_rank/2","title":"OpcUA.Server.read_node_value_rank/2","type":"function"},{"doc":"Reads 'Write Mask' attribute of a node in the server.","ref":"OpcUA.Server.html#read_node_write_mask/2","title":"OpcUA.Server.read_node_write_mask/2","type":"function"},{"doc":"Sets a default Server Config with no network layer and no endpoints.","ref":"OpcUA.Server.html#set_basics/1","title":"OpcUA.Server.set_basics/1","type":"function"},{"doc":"Sets a default Server Config.","ref":"OpcUA.Server.html#set_default_config/1","title":"OpcUA.Server.set_default_config/1","type":"function"},{"doc":"Creates a server configuration with all security policies for the given certificates. The following must be filled: :private_key -&gt; binary() or function(). :certificate -&gt; binary() or function(). :port -&gt; interger().","ref":"OpcUA.Server.html#set_default_config_with_certs/2","title":"OpcUA.Server.set_default_config_with_certs/2","type":"function"},{"doc":"Sets the host name for the Server.","ref":"OpcUA.Server.html#set_hostname/2","title":"OpcUA.Server.set_hostname/2","type":"function"},{"doc":"Sets the configuration for the a Server representing a local discovery server as a central instance. Any other server can register with this server using &quot;discovery_register&quot; function NOTE: before calling this function, this server should have the default configuration. LDS Servers only supports the Discovery Services. Cannot be used in combination with any other capability. The following args must be filled: :application_uri -&gt; binary(). :timeout -&gt; boolean().","ref":"OpcUA.Server.html#set_lds_config/3","title":"OpcUA.Server.set_lds_config/3","type":"function"},{"doc":"Sets a port number for the Server.","ref":"OpcUA.Server.html#set_network_tcp_layer/2","title":"OpcUA.Server.set_network_tcp_layer/2","type":"function"},{"doc":"Sets a port number for the Server.","ref":"OpcUA.Server.html#set_port/2","title":"OpcUA.Server.set_port/2","type":"function"},{"doc":"Adds users (and passwords) the Server. Users must be a tuple list ([{user, password}]).","ref":"OpcUA.Server.html#set_users/2","title":"OpcUA.Server.set_users/2","type":"function"},{"doc":"Start OPC UA Server.","ref":"OpcUA.Server.html#start/1","title":"OpcUA.Server.start/1","type":"function"},{"doc":"Starts up a OPC UA Server GenServer.","ref":"OpcUA.Server.html#start_link/2","title":"OpcUA.Server.start_link/2","type":"function"},{"doc":"Stops a OPC UA Server GenServer.","ref":"OpcUA.Server.html#stop/1","title":"OpcUA.Server.stop/1","type":"function"},{"doc":"Stop OPC UA Server.","ref":"OpcUA.Server.html#stop_server/1","title":"OpcUA.Server.stop_server/1","type":"function"},{"doc":"Change 'Access level' of a node in the server.","ref":"OpcUA.Server.html#write_node_access_level/3","title":"OpcUA.Server.write_node_access_level/3","type":"function"},{"doc":"Change 'Array Dimensions' of a node in the server.","ref":"OpcUA.Server.html#write_node_array_dimensions/3","title":"OpcUA.Server.write_node_array_dimensions/3","type":"function"},{"doc":"Creates a blank 'value array' attribute of a node in the server. Note: the array must match with 'value_rank' and 'array_dimensions' attribute.","ref":"OpcUA.Server.html#write_node_blank_array/4","title":"OpcUA.Server.write_node_blank_array/4","type":"function"},{"doc":"Change the browse name of a node in the server.","ref":"OpcUA.Server.html#write_node_browse_name/3","title":"OpcUA.Server.write_node_browse_name/3","type":"function"},{"doc":"Change 'data_type' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_data_type/3","title":"OpcUA.Server.write_node_data_type/3","type":"function"},{"doc":"Change description attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_description/4","title":"OpcUA.Server.write_node_description/4","type":"function"},{"doc":"Change the display name attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_display_name/4","title":"OpcUA.Server.write_node_display_name/4","type":"function"},{"doc":"Change 'event_notifier' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_event_notifier/3","title":"OpcUA.Server.write_node_event_notifier/3","type":"function"},{"doc":"Change 'Executable' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_executable/3","title":"OpcUA.Server.write_node_executable/3","type":"function"},{"doc":"Change 'Historizing' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_historizing/3","title":"OpcUA.Server.write_node_historizing/3","type":"function"},{"doc":"Change 'Inverse name' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_inverse_name/4","title":"OpcUA.Server.write_node_inverse_name/4","type":"function"},{"doc":"Change 'Is Abstract' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_is_abstract/3","title":"OpcUA.Server.write_node_is_abstract/3","type":"function"},{"doc":"Change 'Minimum Sampling Interval level' of a node in the server.","ref":"OpcUA.Server.html#write_node_minimum_sampling_interval/3","title":"OpcUA.Server.write_node_minimum_sampling_interval/3","type":"function"},{"doc":"Change 'Value' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_value/5","title":"OpcUA.Server.write_node_value/5","type":"function"},{"doc":"Change 'Value rank' of a node in the server. This attribute indicates whether the value attribute of the variable is an array and how many dimensions the array has. It may have the following values: value_rank &gt;= 1: the value is an array with the specified number of dimensions value_rank = 0: the value is an array with one or more dimensions value_rank = -1: the value is a scalar value_rank = -2: the value can be a scalar or an array with any number of dimensions value_rank = -3: the value can be a scalar or a one dimensional array","ref":"OpcUA.Server.html#write_node_value_rank/3","title":"OpcUA.Server.write_node_value_rank/3","type":"function"},{"doc":"Change 'Write Mask' attribute of a node in the server.","ref":"OpcUA.Server.html#write_node_write_mask/3","title":"OpcUA.Server.write_node_write_mask/3","type":"function"},{"doc":"","ref":"OpcUA.Server.html#t:address_space_list/0","title":"OpcUA.Server.address_space_list/0","type":"type"},{"doc":"","ref":"OpcUA.Server.html#t:config_options/0","title":"OpcUA.Server.config_options/0","type":"type"},{"doc":"","ref":"OpcUA.Server.html#t:config_params/0","title":"OpcUA.Server.config_params/0","type":"type"},{"doc":"Base Node Attributes Nodes contain attributes according to their node type. The base node attributes are common to all node types. In the OPC UA services , attributes are referred to via the nodeid of the containing node and an integer attribute-id . In opex62541 we set node_id during the node definition. TODO: add node_id, node_class, references_size, :reference backend","ref":"OpcUA.BaseNodeAttrs.html","title":"OpcUA.BaseNodeAttrs","type":"module"},{"doc":"DataTypeNode DataTypes represent simple and structured data types. DataTypes may contain arrays. But they always describe the structure of a single instance. In open62541, DataTypeNodes in the information model hierarchy are matched to UA_DataType type descriptions for :ref: generic-types via their NodeId. Abstract DataTypes (e.g. Number ) cannot be the type of actual values. They are used to constrain values to possible child DataTypes (e.g. UInt32 ).","ref":"OpcUA.DataTypeNode.html","title":"OpcUA.DataTypeNode","type":"module"},{"doc":"","ref":"OpcUA.DataTypeNode.html#new/2","title":"OpcUA.DataTypeNode.new/2","type":"function"},{"doc":"MethodNode Methods define callable functions and are invoked using the :ref: Call &lt;method-services&gt; service. MethodNodes may have special properties (variable childen with a hasProperty reference) with the :ref: qualifiedname (0, &quot;InputArguments&quot;) and (0, &quot;OutputArguments&quot;) . The input and output arguments are both described via an array of UA_Argument . While the Call service uses a generic array of :ref: variant for input and output, the actual argument values are checked to match the signature of the MethodNode. Note that the same MethodNode may be referenced from several objects (and object types). For this, the NodeId of the method and of the object providing context is part of a Call request message.","ref":"OpcUA.MethodNode.html","title":"OpcUA.MethodNode","type":"module"},{"doc":"","ref":"OpcUA.MethodNode.html#new/2","title":"OpcUA.MethodNode.new/2","type":"function"},{"doc":"A Monitored Item is used to request a server for notifications of each change of value in a specific node.","ref":"OpcUA.MonitoredItem.html","title":"OpcUA.MonitoredItem","type":"module"},{"doc":"Creates a structure for an Monitored Item of an existing node in a Server. The following options must be filled: :monitored_item -&gt; %NodeId(). :sampling_time -&gt; double(). :subscription_id -&gt; integer().","ref":"OpcUA.MonitoredItem.html#new/1","title":"OpcUA.MonitoredItem.new/1","type":"function"},{"doc":"ObjectNode Objects are used to represent systems, system components, real-world objects and software objects. Objects are instances of an object type&lt;objecttypenode&gt; and may contain variables, methods and further objects.","ref":"OpcUA.ObjectNode.html","title":"OpcUA.ObjectNode","type":"module"},{"doc":"","ref":"OpcUA.ObjectNode.html#new/2","title":"OpcUA.ObjectNode.new/2","type":"function"},{"doc":"ObjectTypeNode ObjectTypes provide definitions for Objects. Abstract objects cannot be instantiated.","ref":"OpcUA.ObjectTypeNode.html","title":"OpcUA.ObjectTypeNode","type":"module"},{"doc":"","ref":"OpcUA.ObjectTypeNode.html#new/2","title":"OpcUA.ObjectTypeNode.new/2","type":"function"},{"doc":"","ref":"OpcUA.ReferenceNode.html","title":"OpcUA.ReferenceNode","type":"module"},{"doc":"","ref":"OpcUA.ReferenceNode.html#new/2","title":"OpcUA.ReferenceNode.new/2","type":"function"},{"doc":"ReferenceTypeNode Each reference between two nodes is typed with a ReferenceType that gives meaning to the relation. The OPC UA standard defines a set of ReferenceTypes as a mandatory part of OPC UA information models. Abstract ReferenceTypes cannot be used in actual references and are only used to structure the ReferenceTypes hierarchy Symmetric references have the same meaning from the perspective of the source and target node","ref":"OpcUA.ReferenceTypeNode.html","title":"OpcUA.ReferenceTypeNode","type":"module"},{"doc":"","ref":"OpcUA.ReferenceTypeNode.html#new/2","title":"OpcUA.ReferenceTypeNode.new/2","type":"function"},{"doc":"VariableNode Variables store values in a value together with metadata for introspection. Most notably, the attributes data type, value_rank and array dimensions constrain the possible values the variable can take on. Variables come in two flavours: properties and datavariables. Properties are related to a parent with a hasProperty reference and may not have child nodes themselves. Datavariables may contain properties ( hasProperty ) and also datavariables ( hasComponents ). All variables are instances of some variabletypenode in return constraining the possible data type, value rank and array dimensions attributes. Data Type The (scalar) data type of the variable is constrained to be of a specific type or one of its children in the type hierarchy. The data type is given as a NodeId pointing to a DataTypeNode in the type hierarchy. See the Section DataTypeNode for more details. If the data type attribute points to UInt32 , then the value attribute must be of that exact type since UInt32 does not have children in the type hierarchy. If the data type attribute points Number , then the type of the value attribute may still be UInt32 , but also Float or Byte . Consistency between the data type attribute in the variable and its VariableTypeNode is ensured. Value Rank This attribute indicates whether the value attribute of the variable is an array and how many dimensions the array has. It may have the following values: n &gt;= 1 : the value is an array with the specified number of dimensions n = 0 : the value is an array with one or more dimensions n = -1 : the value is a scalar n = -2 : the value can be a scalar or an array with any number of dimensions n = -3 : the value can be a scalar or a one dimensional array Consistency between the value rank attribute in the variable and its variabletypenode is ensured. TODO: Array Dimensions If the value rank permits the value to be a (multi-dimensional) array, the exact length in each dimensions can be further constrained with this attribute. For positive lengths, the variable value is guaranteed to be of the same length in this dimension. The dimension length zero is a wildcard and the actual value may have any length in this dimension. Consistency between the array dimensions attribute in the variable and its variabletypenode is ensured. Indicates whether a variable contains data inline or whether it points to an external data source.","ref":"OpcUA.VariableNode.html","title":"OpcUA.VariableNode","type":"module"},{"doc":"","ref":"OpcUA.VariableNode.html#new/2","title":"OpcUA.VariableNode.new/2","type":"function"},{"doc":"VariableTypeNode VariableTypes are used to provide type definitions for variables. VariableTypes constrain the data type, value rank and array dimensions attributes of variable instances. Furthermore, instantiating from a specific variable type may provide semantic information. For example, an instance from MotorTemperatureVariableType is more meaningful than a float variable instantiated from BaseDataVariable .","ref":"OpcUA.VariableTypeNode.html","title":"OpcUA.VariableTypeNode","type":"module"},{"doc":"","ref":"OpcUA.VariableTypeNode.html#new/2","title":"OpcUA.VariableTypeNode.new/2","type":"function"},{"doc":"ViewNode Each View defines a subset of the Nodes in the AddressSpace. Views can be used when browsing an information model to focus on a subset of nodes and references only. ViewNodes can be created and be interacted with. But their use in the :ref: Browse&lt;view-services&gt; service is currently unsupported in open62541.","ref":"OpcUA.ViewNode.html","title":"OpcUA.ViewNode","type":"module"},{"doc":"","ref":"OpcUA.ViewNode.html#new/2","title":"OpcUA.ViewNode.new/2","type":"function"},{"doc":"A NodeId that allows the namespace URI to be specified instead of an index.","ref":"OpcUA.ExpandedNodeId.html","title":"OpcUA.ExpandedNodeId","type":"module"},{"doc":"Creates a structure for an expanded node in the address space of an OPC UA Server.","ref":"OpcUA.ExpandedNodeId.html#new/1","title":"OpcUA.ExpandedNodeId.new/1","type":"function"},{"doc":"An identifier for a node in the address space of an OPC UA Server. An OPC UA information model is made up of nodes and references between nodes. Every node has a unique NodeId. NodeIds refer to a namespace with an additional identifier value that can be an integer, a string, a guid or a bytestring depending on the selected identifier_type .","ref":"OpcUA.NodeId.html","title":"OpcUA.NodeId","type":"module"},{"doc":"Creates a structure for a node in the address space of an OPC UA Server.","ref":"OpcUA.NodeId.html#new/1","title":"OpcUA.NodeId.new/1","type":"function"},{"doc":"A name qualified by a namespace.","ref":"OpcUA.QualifiedName.html","title":"OpcUA.QualifiedName","type":"module"},{"doc":"Creates a structure for a name qualified by a namespace.","ref":"OpcUA.QualifiedName.html#new/1","title":"OpcUA.QualifiedName.new/1","type":"function"},{"doc":"Documentation for Opex62541.","ref":"Opex62541.html","title":"Opex62541","type":"module"},{"doc":"Opex62541 is an Elixir wrapper for the open62541 library; open62541 is an open-source implementation of OPC UA (OPC Unified Architecture) aka IEC 62541 licensed under Mozilla Public License v2.0.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Features Installation Compatibility Nerves Customized build Documentation Contributing License TODO","ref":"readme.html#content","title":"README - Content","type":"extras"},{"doc":"This library implements the following features from open62541 : Communication Stack OPC UA binary protocol Secure communication with encrypted messages Server Support for all OPC UA node types Access control for individual nodes Support for adding and removing nodes and references also at runtime. Support for inheritance and instantiation of object and variable-types. Support for subscriptions/monitored items. Client All OPC UA services supported Support for subscriptions/monitored items.","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"To install this package, add opex62541 to your list of dependencies in mix.exs : def deps do [ { :opex62541 , git : &quot;https://github.com/valiot/opex62541&quot; } ] end Compatibility Opex62541 was developed for open62541 &quot;1.0.0&quot; with Elixir 1.10.0. It was tested on: Ubuntu 18.04, 20.04 Raspbian OS (Raspberry Pi 3B+) Nerves (Raspberry Pi 3B+) Adding the following opex62541 dependencies to build the package: sudo apt-get install git build-essential gcc pkg-config cmake python libmbedtls-dev Nerves Nerves is a complete IoT platform and infrastructure to build and deploy maintainable embedded systems to boards such as Raspberry Pi or Beaglebone. To add opex62541 dependency ( mbedtls ) to your Nerves project, you need to create a Nerves Custom System and add the following lines to the nerves_defconfig file: BR2_PACKAGE_MBEDTLS=y BR2_PACKAGE_MBEDTLS_COMPRESSION=y Customized builds By default, Opex62541 downloads and compiles the v1.0 release of open62541. If you want to compile it manually or change the default version, use the following example commands to set the desired env variables: export MANUAL_BUILD=true export OPEN62541_DOWNLOAD_VERSION=v1.0.1 The open62541 project uses CMake to manage the build options for code generation and to generate build projects for the different systems and IDEs. To overwrite the default options, use OPEN62541_BUILD_ARGS as follows: export OPEN62541_BUILD_ARGS=&#39;-DCMAKE_BUILD_TYPE=Release -DUA_NAMESPACE_ZERO=MINIMAL&#39; Default values for OPEN62541_BUILD_ARGS are -DBUILD_SHARED_LIBS=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo -DUA_NAMESPACE_ZERO=FULL -DUA_LOGLEVEL=601 -DUA_ENABLE_DISCOVERY_MULTICAST=ON -DUA_ENABLE_AMALGAMATION=ON -DUA_ENABLE_ENCRYPTION=ON .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"To build the container locally use: git clone https://github.com/valiot/opex62541 cd opex62541 docker build -t &lt;name:tag&gt; . You can use this container to test this application.","ref":"readme.html#docker-container","title":"README - Docker Container","type":"extras"},{"doc":"For detailed documentation and tutorials refer to hexdocs.pm .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"Fork our repository on Github. Fix or add what is needed. Commit to your repository Issue a Github Pull Request. Fill the pull request template. If you wish to clone this repository, use: git clone https :// github . com / valiot / opex62541 . git","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"See LICENSE .","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Methods OPC UA PubSub Better C code handling for the Client and Server common code","ref":"readme.html#todo","title":"README - TODO","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Elixir 1.12 (OTP 24) support. Dockerfile added. README.md update.","ref":"changelog.html#0-1-2","title":"Changelog - 0.1.2","type":"extras"},{"doc":"exdoc dependency added. Hexdocs support. README.md update. Guide files &amp; section added. Changelog file added.","ref":"changelog.html#0-1-1","title":"Changelog - 0.1.1","type":"extras"},{"doc":"","ref":"introduction.html","title":"Introduction","type":"extras"},{"doc":"OPC UA Tutorials Lifecycle Security Discovery Information Manipulation Elixir Integration Development","ref":"introduction.html#content","title":"Introduction - Content","type":"extras"},{"doc":"OPC UA (Unified Architecture) extends the great success of the OPC communication protocol for data acquisition, information modeling (object-oriented), and communication between plant and applications (client-server) reliably and securely. OPC UA is based on a service-oriented approach defined by the IEC 62451 standard. Opex62541 wraps the basic functions of OPC UA client and server.","ref":"introduction.html#opc-ua","title":"Introduction - OPC UA","type":"extras"},{"doc":"The purpose of the following sections is to provide a guided tour of using this library in simple applications. First, we will explain the most important features and the manual way to use the library (such as configuration, connectivity, data modeling, and execution). And finally, we will show automatic methods to configure and integrate the library with the elixir module. Lifecycle This section shows how the life cycle of an OPC UA client and server should be executed. We will see configuration and connectivity topics. Security Next, we will focus on adding a more robust security layer. We will show you the security modes we support and how to configure them. Discovery We will discuss the interaction between an OPC UA client or server and a network, i.e., on the server-side, how to become visible to clients, and on the client-side, how to scan the network to identify a server. In this section, we will configure a Local Discovery Server (LDS), register a server in it, and retrieve information. Information Manipulation We will explore how the information is modeled in OPC UA, the methods to add the model to the server, and how clients can extract the data. Topics such as Address space, Nodes, Monitored Items, etc., will be covered. Elixir Integration Finally, we will discuss a callback-based interface that facilitates the configuration and integration between the server or client and an elixir module.","ref":"introduction.html#tutorials","title":"Introduction - Tutorials","type":"extras"},{"doc":"Opex62541 is an Elixir wrapper for the open62541 library (C Code). Therefore, two middlewares ( opc_ua_client.c and opc_ua_server.c ) were made to execute open62541 API functions based on stdio messages, this communication between Elixir and C middleware is established by creating a port ( Erlang's Port Module ), which allows possible errors in the C code to be contained.","ref":"introduction.html#development","title":"Introduction - Development","type":"extras"},{"doc":"This tutorial will cover the following topics:","ref":"lifecycle.html","title":"Lifecycle","type":"extras"},{"doc":"Server Server Configuration Basic Authentication Start / Stop Client Client Configuration Connection By URL By Username No Session","ref":"lifecycle.html#content","title":"Lifecycle - Content","type":"extras"},{"doc":"The code in this example shows the three parts for OPC UA Server lifecycle management: Creating a Server, set configuration Server, and running the Server. Basic use of the Server module. The OPC UA Server is based on a GenServer . Therefore it can spawn a new server by using start_link . alias OpcUA.Server { :ok , server_pid } = Server . start_link ( ) Server Configuration The easiest way to configure the server is using the set_default_config/1 function, as shown in the following code: :ok = Server . set_default_config ( server_pid ) By default the hostname is given by the localhost, however it is possible to overwrite its value by using set_hostname/2 : :ok = Server . set_hostname ( server_pid , &quot;opex-server&quot; ) Note : Be aware of DNS configuration. It is also possible to change the default port as follows. :ok = Server . set_port ( server_pid , 4040 ) Note : Default port value is 4840. Basic Authentication Security is a fundamental aspect of OPC UA. It is possible to restrict access to the server by defining authorized users as shown bellow: :ok = Server . set_users ( server_pid , [ { &quot;alde103&quot; , &quot;103alde&quot; } , { &quot;pedro&quot; , &quot;ordep&quot; } ] ) In this example, we declare two users (alde103 and pedro) with their respective passwords. Note : This is not the best way to secure your OPC UA Server. Refer to Security tutorial for a better approach. Start / Stop At this point, the server will not accept requests yet. Use the start/1 function to start the server explicitly. :ok = Server . start ( server_pid ) The Server can be stopped with the stop_server/1 function. :ok = Server . stop_server ( server_pid )","ref":"lifecycle.html#server","title":"Lifecycle - Server","type":"extras"},{"doc":"The code in this example shows the three parts for OPC UA Client lifecycle management: creating, configuring, and connecting a client to a server. Basic use of the Client module. The OPC UA Client is based on a GenServer . Therefore it can spawn a new server by using start_link . alias OpcUA.Client { :ok , client_pid } = Client . start_link ( ) Configuration The client can be configured using the following function, :ok = Client . set_config ( client_pid ) it is possible to overwrite some connection parameters (such as timeouts) by using set_hostname/2 , config = %{ &quot;requestedSessionTimeout&quot; =&gt; 12000 , &quot;secureChannelLifeTime&quot; =&gt; 6000 , &quot;timeout&quot; =&gt; 500 } :ok = Client . set_config ( client_pid , config ) Note : Use get_config/1 function to check the current client configuration. Connection OPC UA provides a client-server communication model that includes status information. This status information is associated with a session. The user can check the connection status through get_state/1 function: { :ok , &quot;Disconnected&quot; } = Client . get_state ( client_pid ) By URL The Client can connect to a Server by using connect_by_url/2 and providing the Server's URL as follows: url = &quot;opc.tcp://localhost:4048/&quot; :ok = Client . connect_by_url ( client_pid , url : url ) { :ok , &quot;Session&quot; } = Client . get_state ( client_pid ) By Username If the Server has some user restriction, the client must provide the username and password to access the Server. If this is your case, use connect_by_username/2 url = &quot;opc.tcp://localhost:4840/&quot; user = &quot;alde103&quot; password = &quot;103adle&quot; :ok = Client . connect_by_username ( client_pid , url : url , user : user , password : password ) No Session There may be situations where a session is not required. For those cases use connect_no_session/2 url = &quot;opc.tcp://localhost:4048/&quot; :ok = Client . connect_no_session ( c_pid , url : url ) { :ok , &quot;Secure Channel&quot; } = Client . get_state ( c_pid )","ref":"lifecycle.html#client","title":"Lifecycle - Client","type":"extras"},{"doc":"This tutorial will cover the following topics:","ref":"security.html","title":"Security","type":"extras"},{"doc":"Security Model Server Manual Configuration Client Security Modes","ref":"security.html#content","title":"Security - Content","type":"extras"},{"doc":"The OPC UA security model is implemented by defining a secure channel on which a session is based. A secure channel has the following features: Digital signatures ensure the integrity of the data. Encryption ensures confidentiality. Authentication and authorization of applications by using X.509 certificates. A secure channel is related to an endpoint, and each server offers one or more endpoints. Each endpoint has the following features: Server application instance certificate: This is the public key of the server used by the client to make the exchange of data secure. Security policy: A set of algorithms used in security mechanisms. Security mode: There are three different modes: None, Sign, or SignAndEncrypt. Authentication: The mechanisms used to authenticate a user during the creation of a session (by username, a certificate, or anonymous authentication). Transport protocol: Defines the network protocol that is going to be used. Endpoint URL: The network address used by the client to establish a secure channel with the endpoint. Since this feature requires certificates to work, it is the user's responsibility to provide a valid certificate to the server or client.","ref":"security.html#security-model","title":"Security - Security Model","type":"extras"},{"doc":"Assuming that an OPC UA Server has been created as shown in Lifecycle tutorial. The easiest way to configure the security requirements of the server is by using the set_default_config_with_certs/2 function, as shown in the following code: alias OpcUA.Server certs_config = [ port : 4840 , certificate : File . read! ( &quot;./test/demo_certs/server_cert.der&quot; ) , private_key : File . read! ( &quot;./test/demo_certs/server_key.der&quot; ) ] :ok = Server . set_default_config_with_certs ( server_pid , certs_config )","ref":"security.html#server","title":"Security - Server","type":"extras"},{"doc":"By default, the previous method sets all internal basic configuration, a TCP network layer (with port 4840), and all supported security policies. However, this configuration can be done manually to fit your application. Next we will detail step by step how to set the manual configuration as follows: Step 1: Set the internal (open62451) basics: :ok = Server . set_basics ( server_pid ) Step 2: Set the Transport Protocol with a given port (4041, for example): :ok = Server . set_network_tcp_layer ( server_pid , 4041 ) Step 3: Set the Security Policies, Currently this library supports the following: None. Basic128Rsa15. Basic256 Basic256Sha256. The following code adds the security policy SecurityPolicy#None to the server. certs_info = [ certificate : File . read! ( &quot;./test/demo_certs/server_cert.der&quot; ) ] :ok = Server . add_none_policy ( server_pid , certs_info ) To add the security policy SecurityPolicy#Basic128Rsa15 to the server use the next code, certs_info = [ certificate : File . read! ( &quot;./test/demo_certs/server_cert.der&quot; ) , private_key : File . read! ( &quot;./test/demo_certs/server_key.der&quot; ) ] :ok = Server . add_basic128rsa15_policy ( server_pid , certs_info ) the next code adds the security policy SecurityPolicy#Basic256 to the server, certs_info = [ certificate : File . read! ( &quot;./test/demo_certs/server_cert.der&quot; ) , private_key : File . read! ( &quot;./test/demo_certs/server_key.der&quot; ) ] :ok = Server . add_basic256_policy ( server_pid , certs_info ) the security policy SecurityPolicy#Basic256Sha256 can be added to the server using add_basic256sha256_policy/2 , certs_info = [ certificate : File . read! ( &quot;./test/demo_certs/server_cert.der&quot; ) , private_key : File . read! ( &quot;./test/demo_certs/server_key.der&quot; ) ] :ok = Server . add_basic256sha256_policy ( server_pid , certs_info ) Using add_all_policies/2 adds all supported security policies and sets up certificate validation procedures. certs_info = [ certificate : File . read! ( &quot;./test/demo_certs/server_cert.der&quot; ) , private_key : File . read! ( &quot;./test/demo_certs/server_key.der&quot; ) ] :ok = Server . add_all_policies ( server_pid , certs_info ) Step 4: Finally, the following code adds an endpoint for every configured security policy to the server. :ok = Server . add_all_endpoints ( server_pid , 4041 )","ref":"security.html#manual-configuration","title":"Security - Manual Configuration","type":"extras"},{"doc":"Assuming that an OPC UA Client has been created as shown in Lifecycle tutorial. The certificate and private key can be set as follow: certs_config = [ security_mode : 2 , certificate : File . read! ( &quot;./test/demo_certs/client_cert.der&quot; ) , private_key : File . read! ( &quot;./test/demo_certs/client_key.der&quot; ) ] :ok = Client . set_config_with_certs ( client_pid , certs_config )","ref":"security.html#client","title":"Security - Client","type":"extras"},{"doc":"If the certificate is reliable, the client sends an Open Secure Channel request in line with the security policy and the security mode of the selected session endpoint; in the set_config_with_certs/2 , the security_mode option only accepts integers ([1, 2, 3]) and represents the following: None (1), the request will be sent without any security mechanisms. Sign (2), the request will be sent using the client's private key as a signature. SignAndEncrypt (3), the request will be sent after encrypting it using the server's public key. Once the client is configured, you can connect the client to the server using the functions exposed in the Lifecycle tutorial.","ref":"security.html#security-modes","title":"Security - Security Modes","type":"extras"},{"doc":"This tutorial will cover the following topics:","ref":"discovery.html","title":"Discovery","type":"extras"},{"doc":"Local Discovery Server Server LDS Configuration Registration Client Scanning Network","ref":"discovery.html#content","title":"Discovery - Content","type":"extras"},{"doc":"The Local Discovery Server (LDS) provides the necessary infrastructure to publicly expose the OPC UA Servers available on a given computer. OPC UA Servers will periodically connect to the LDS and Register themselves as being available. This periodic activity means that the list of available OPC UA servers is always current and means that an OPC UA client can immediately connect to any of them.","ref":"discovery.html#local-discovery-server","title":"Discovery - Local Discovery Server","type":"extras"},{"doc":"Assuming that an OPC UA Server has been created and configured as shown in Lifecycle tutorial.","ref":"discovery.html#server","title":"Discovery - Server","type":"extras"},{"doc":"To spawn an LDS server, follow these steps. alias OpcUA.Server { :ok , lds_pid } = Server . start_link ( ) :ok = Server . set_default_config ( lds_pid ) application_uri = &quot;urn:opex62541.test.local_discovery_server&quot; :ok = Server . set_lds_config ( lds_pid , application_uri ) Note : LDS Servers only supports the Discovery Services. Therefore, it cannot be used in combination with any other capability.","ref":"discovery.html#lds-configuration","title":"Discovery - LDS Configuration","type":"extras"},{"doc":"The LDS maintains a list of available servers which servers may use to announce their existence to clients. Any other server can register with this server using discovery_register/2 function as shown below: alias OpcUA.Server { :ok , server_pid } = Server . start_link ( ) :ok = Server . set_default_config ( server_pid ) application_uri = &quot;urn:opex62541.test.local_register_server&quot; :ok = Server . discovery_register ( server_pid , application_uri : application_uri , server_name : &quot;TestRegister&quot; , endpoint : &quot;opc.tcp://localhost:4840&quot; ) The endpoint option represents the LDS endpoint, and the server_name is how the registered server will be visible in the network. The discovery_unregister can be used to delete the desired server from the LDS server. :ok = Server . discovery_unregister ( server_pid )","ref":"discovery.html#registration","title":"Discovery - Registration","type":"extras"},{"doc":"Clients may request a list of all available servers from the discovery server (LDS) and then use the GetEndpoints service to get the connection information from a server. Assuming you have an LDS server with a registered server alias OpcUA.Server #LDS Server { :ok , lds_pid } = Server . start_link ( ) :ok = Server . set_port ( lds_pid , 4050 ) :ok = Server . set_lds_config ( lds_pid , &quot;urn:opex62541.test.local_discovery_server&quot; ) :ok = Server . start ( lds_pid ) #Normal OPC UA Server { :ok , s_pid } = Server . start_link ( ) :ok = Server . set_port ( s_pid , 4048 ) :ok = Server . discovery_register ( s_pid , application_uri : &quot;urn:opex62541.test.local_register_server&quot; , server_name : &quot;testRegister&quot; , endpoint : &quot;opc.tcp://localhost:4050&quot; ) :ok = Server . start ( s_pid ) # Registration time Process . sleep ( 1500 ) Scanning Network To discover all OPC UA Server in the network, you can use find_servers_on_network/2 , alias OpcUA.Client { :ok , c_pid } = Client . start_link ( ) :ok = Client . set_config ( c_pid ) # LDS Server url url = &quot;opc.tcp://localhost:4050/&quot; Client . find_servers_on_network ( c_pid , url ) # this response may change depending on your computer { :ok , [ %{ &quot;capabilities&quot; =&gt; [ &quot;LDS&quot; ] , &quot;discovery_url&quot; =&gt; &quot;opc.tcp://localhost:4050&quot; , &quot;record_id&quot; =&gt; 0 , &quot;server_name&quot; =&gt; &quot;LDS-localhost&quot; } , %{ &quot;capabilities&quot; =&gt; [ &quot;NA&quot; ] , &quot;discovery_url&quot; =&gt; &quot;opc.tcp://localhost:4048&quot; , &quot;record_id&quot; =&gt; 1 , &quot;server_name&quot; =&gt; &quot;testRegister-localhost&quot; } ] } If you require more detailed information, you can use the find_server/2 function. Client . find_servers ( c_pid , url ) # this response may change depending on your computer { :ok , [ %{ &quot;discovery_url&quot; =&gt; [ &quot;opc.tcp://localhost:4050/&quot; ] , &quot;name&quot; =&gt; &quot;open62541-based OPC UA Application&quot; , &quot;product_uri&quot; =&gt; &quot;http://open62541.org&quot; , &quot;application_uri&quot; =&gt; &quot;urn:opex62541.test.local_discovery_server&quot; , &quot;server&quot; =&gt; &quot;urn:opex62541.test.local_discovery_server&quot; , &quot;type&quot; =&gt; &quot;discovery_server&quot; } , %{ &quot;application_uri&quot; =&gt; &quot;urn:opex62541.test.local_register_server&quot; , &quot;discovery_url&quot; =&gt; [ &quot;opc.tcp://localhost:4048/&quot; , &quot;opc.tcp://localhost:4048/&quot; ] , &quot;name&quot; =&gt; &quot;open62541-based OPC UA Application&quot; , &quot;product_uri&quot; =&gt; &quot;http://open62541.org&quot; , &quot;server&quot; =&gt; &quot;urn:opex62541.test.local_register_server&quot; , &quot;type&quot; =&gt; &quot;server&quot; } ] } Finally, to get the server endpoints, you can use the get_endpoints/2 function. url = &quot;opc.tcp://localhost:4048&quot; Client . get_endpoints ( c_pid , url ) # this response may change depending on your computer { :ok , [ %{ &quot;endpoint_url&quot; =&gt; &quot;opc.tcp://localhost:4048&quot; , &quot;security_level&quot; =&gt; 1 , &quot;security_mode&quot; =&gt; &quot;none&quot; , &quot;security_profile_uri&quot; =&gt; &quot;http://opcfoundation.org/UA/SecurityPolicy#None&quot; , &quot;transport_profile_uri&quot; =&gt; &quot;http://opcfoundation.org/UA-Profile/Transport/uatcp-uasc-uabinary&quot; } ] }","ref":"discovery.html#client","title":"Discovery - Client","type":"extras"},{"doc":"This tutorial will cover the following topics:","ref":"information-manipulation.html","title":"Information Manipulation","type":"extras"},{"doc":"Information Model Server Address Space Nodes Object Nodes Variable Nodes Read/Write Nodes Monitored Items Write Events Examples Client Read/Write Node Monitored Item Example Information Model The information model is an abstract representation of the real objects that you need to manage in your application. The same pieces of physical equipment and the associated pieces of information can be modeled in different ways according to the specific process and environment requirements. The basic principles of information modeling in OPC UA are as follows: Use of object-oriented techniques, including hierarchies and inheritance. The same mechanism is used to access the types and the instances. The hierarchies of the data types and the links between the nodes are extendable. There are no limitations on how to model information. Information modeling is always placed on the server-side.","ref":"information-manipulation.html#content","title":"Information Manipulation - Content","type":"extras"},{"doc":"Assuming that an OPC UA Server has been created and configured as shown in Lifecycle tutorial. Address Space The set of objects and related information that an OPC UA server makes available to the clients is the address space. The address space of the OPC UA is a set of nodes that are connected by references. Each node has properties, which are called attributes. In this library, we use one namespace per address space, so we will use the namespace to refer to an address space. To add a new namespace to your server use add_namespace/2 : alias OpcUA . { NodeId , QualifiedName , Server } { :ok , ns_index } = Server . add_namespace ( server_pid , &quot;Room&quot; ) These functions take a configured OPC UA Server PID and an identifier as a unique string. It will return an index to be used as a reference to create the related nodes. Nodes In OPC UA, every entity in the address space is a node. To uniquely identify a Node, each node has a NodeId; to create new NodeId's, use the NodeId module, for example: requested_new_node_id = NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 1000 ) In this example, we have created a NodeId corresponding to i=1000 (namespace index 0, numeric identifier, id 1000, according to OPC UA XML Schema) Note : You can use the zero namespace index when you are referring to builtin nodes. There are eight standard node classes: variable, object, method, view, data type, variable type, object type, and reference type. However, for this tutorial, we will describe an example of how to define object nodes and variable nodes. Note : Currently, only the method node is not supported yet. For this tutorial, we will model a temperature sensor by creating an object node of the sensor and a variable node representing the temperature. Object Nodes The object node class structures the address space and can be used to group variables, methods, or other objects. requested_new_node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature-Sensor&quot; ) parent_node_id = NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 85 ) reference_type_node_id = NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 35 ) browse_name = QualifiedName . new ( ns_index : ns_index , name : &quot;Temperature sensor&quot; ) type_definition = NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 58 ) :ok = Server . add_object_node ( server_pid , requested_new_node_id : requested_new_node_id , parent_node_id : parent_node_id , reference_type_node_id : reference_type_node_id , browse_name : browse_name , type_definition : type_definition ) For this case, we are define an object node as a BaseObjectType defined by type_definition (wildcard for object nodes i=58 ) with a ns=1;s=R1_TS1_Temperature-Sensor NodeId (OPC UA XML Schema) using requested_new_node_id , which parent node is an ObjectsFolder ( parent_node_id i=85 ), it uses a Organizes ( i=35 ) relationship and the clients should see the object node as Temperature sensor defined by browse_name . Note : All nodes that use ns_index: 0 are zero namespace nodes id index , which means that they are defined by OPC UA standard. Variable Nodes The variable node class represents a value. Clients can read, write, or subscribe to it (monitored items). Now we are going to add a variable node (to holds the Temperature value) to our object node just as shown in the following example: requested_new_node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) parent_node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature-Sensor&quot; ) reference_type_node_id = NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 47 ) browse_name = QualifiedName . new ( ns_index : ns_index , name : &quot;Temperature&quot; ) type_definition = NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 63 ) :ok = Server . add_variable_node ( server_pid , requested_new_node_id : requested_new_node_id , parent_node_id : parent_node_id , reference_type_node_id : reference_type_node_id , browse_name : browse_name , type_definition : type_definition ) For this case, we are define an object node as a BaseDataVariableType defined by type_definition (wildcard for variable nodes i=63 ) with a ns=1;s=R1_TS1_Temperature NodeId (OPC UA XML Schema) using requested_new_node_id , which parent node is the R1_TS1_Temperature-Sensor defined previously, it uses a HasComponent ( i=47 ) relationship and the clients should see the variable node as Temperature defined by browse_name . Read/Write Nodes Depending on the type of node (object, variable, reference, etc.), it's attributes can change. When the node is created, its attributes will have a default value. However, you can read and write its value using the Server module. The following example changes the access level and the value of the node. node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) # CurrentWrite, CurrentRead :ok = Server . write_node_access_level ( server_pid , node_id , 3 ) { :ok , 3 } = Server . read_node_access_level ( server_pid , node_id ) # Change the Node Value. :ok = Server . write_node_value ( server_pid , node_id , 0 , true ) { :ok , true } = Server . read_node_value ( server_pid , node_id ) :ok = Server . write_node_value ( server_pid , node_id , 1 , 103 ) { :ok , 103 } = Server . read_node_value ( server_pid , node_id ) First, we set the access_level to CurrentWrite and CurrentRead (3). Therefore the client has access to its value. Then we change the value from a Boolean (0) to a Byte (1) value (this is possible thanks to the variable wildcard that we use before). Note : It is recommended to change the writing mask and the access level node attributes. The data_type and value argument of write_node_value/4 must be congruent, therefore, it is recommended to review the official data types . Monitored Items Clients can subscribe to variable nodes through monitored items . A monitored item is used to request an OPC UA server for notifications of each change of value in a specific node. node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) # Add Temperature as a Monitored Item { :ok , 1 } = Server . add_monitored_item ( server_pid , monitored_item : node_id , sampling_time : 1000.0 ) # Deletes Monitored Item :ok = Server . delete_monitored_item ( server_pid , 1 ) Write Event Nodes Each time a node value is updated, the Server module sends a message to the parent process in de form of {node_id, value} Therefore, this feature can be handled by a module, as illustrated in the following example: defmodule MyServer do use OpcUA.Server require Logger def handle_write ( { node_id , value } , state ) do Logger . debug ( &quot;Value changed \#{ value } in \#{ node_id } Node&quot; ) state end end Examples More examples can be found in the source code tests .","ref":"information-manipulation.html#server","title":"Information Manipulation - Server","type":"extras"},{"doc":"Assuming that an OPC UA Client has been created, configured, and connected to an OPC UA Server as shown in Lifecycle tutorial. Read/Write Node You can read and write its attribute value by using the Client module. The following example changes the value of the node. node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) # Writes a Byte :ok = Client . write_node_value ( client_pid , node_id , 1 , 21 ) # Reads a Byte { :ok , 21 } = Client . read_node_value ( client_pid , node_id ) Monitored Item To request a monitored item to a server, the client must first request a subscription request. Then the client must request the monitored item. node_id = NodeId . new ( ns_index : ns_index , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) # Creates a subscription channels. { :ok , 1 } = Client . add_subscription ( client_pid ) # Request a monitored item. { :ok , 1 } = Client . add_monitored_item ( client_pid , monitored_item : node_id , subscription_id : 1 ) Example More examples can be found in the source code tests .","ref":"information-manipulation.html#client","title":"Information Manipulation - Client","type":"extras"},{"doc":"","ref":"elixir-integration.html","title":"Elixir Integration","type":"extras"},{"doc":"Integration Server Server Configuration Address Space Write Events Examples Client Client Configuration Monitored Item Subscription Example","ref":"elixir-integration.html#content","title":"Elixir Integration - Content","type":"extras"},{"doc":"Both Server and Client modules are implemented as a __using__ macro so that you can put it in any module; you only need to add the defined callbacks to integrate this library into your project. Either way, it is always possible to directly use Server and Client modules, as shown in previous tutorials.","ref":"elixir-integration.html#integration","title":"Elixir Integration - Integration","type":"extras"},{"doc":"For convenience, Server is a GenServer wrapper for automating configuration and adding the address space (information model); it also accepts the same options for supervision to configure the child spec and passes them along to GenServer , for example: use OpcUA.Server , restart : :transient , shutdown : 10_000 With these instructions, the Server backend will be integrated into your application module. Now you only have to add the callbacks you require. The basic callback is the init/2 that let you manipulate the OPC UA server by given it's PID (opc_ua_server_pid) with some user data (user_init_state): # Use the `init` function to configure your server. def init ( user_init_state , opc_ua_server_pid ) do # Do some initial process and start the server at your convenience. Server . start ( opc_ua_server_pid ) # You can set a new state for your app (if required). user_init_state end Note : No callback automatically starts the OPC UA server, so it is recommended to use init\\2 because it is the last callback to be executed. Server Configuration The first executed optional callback is configuration/1 . It gets and executes the Server configuration and discovery connection parameters as follows: def configuration ( _user_init_state ) do [ config : [ port : 4041 , users : [ { &quot;alde103&quot; , &quot;secret&quot; } ] ] ] end In this example, the server will use the port 4041 with a predefined user. The user_init_state is propagated to this callback too. Note : The output of these callbacks must be a list (type config_options) as shown in the Server module. Address Space The next executed optional callback is address_space/1 . It gets and adds all nodes (namespaces, object nodes, variable nodes, monitored items) to the Server as follows: def address_space ( _user_init_state ) do [ namespace : &quot;Sensor&quot; , object_node : OpcUA.ObjectNode . new ( [ requested_new_node_id : NodeId . new ( ns_index : 2 , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Sensor&quot; ) , parent_node_id : NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 85 ) , reference_type_node_id : NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 35 ) , browse_name : QualifiedName . new ( ns_index : 2 , name : &quot;Temperature sensor&quot; ) , type_definition : NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 58 ) ] ) , variable_node : OpcUA.VariableNode . new ( [ requested_new_node_id : NodeId . new ( ns_index : 2 , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) , parent_node_id : NodeId . new ( ns_index : 2 , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Sensor&quot; ) , reference_type_node_id : NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 47 ) , browse_name : QualifiedName . new ( ns_index : 2 , name : &quot;Temperature&quot; ) , type_definition : NodeId . new ( ns_index : 0 , identifier_type : &quot;integer&quot; , identifier : 63 ) ] , write_mask : 0x3FFFFF , value : { 10 , 103.0 } , access_level : 3 ) , monitored_item : OpcUA.MonitoredItem . new ( [ monitored_item : NodeId . new ( ns_index : 2 , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) , sampling_time : 1000.0 , subscription_id : 1 ] ) ] end This example emulates a temperature sensor based on an object node ( R1_TS1_Sensor ) with a variable node ( R1_TS1_Temperature ) to display the temperature, which is registered as a monitored item. The user_init_state is propagated to this callback too. Note : The output of these callbacks must be a list (type address_space_list) as shown in the Server module. The order matters according to the node dependency. In this example, the parent node of the variable node is an object node. If the object node is not defined at the variable node definition time, the server will crash. Write Events A runtime callback is handle_write/2 . It handles every Client writing events to any Server node, as follows: def handle_write ( write_event , state ) do # Do something with the write event ({node_id, value} = write_event) # and your module state (state) state end Examples The following example shows a module that takes its configuration from the environment: defmodule MyServer do use OpcUA.Server alias OpcUA . { NodeId , Server , QualifiedName } # Use the `init` function to configure your server. def init ( user_init_state , opc_ua_server_pid ) do # Do some initial process and start the server at your convenience. Server . start ( opc_ua_server_pid ) # You can set a new state for your app. user_init_state end def configuration ( _user_init_state ) , do : Application . get_env ( :opex62541 , :configuration , [ ] ) def address_space ( _user_init_state ) , do : Application . get_env ( :opex62541 , :address_space , [ ] ) def handle_write ( write_event , %{ parent_pid : parent_pid } = state ) do send ( parent_pid , write_event ) state end end This code can be executed as { :ok , my_pid } = MyServer . start_link ( { self ( ) , 103 } = _user_init_state ) More examples can be found in the source code tests .","ref":"elixir-integration.html#server","title":"Elixir Integration - Server","type":"extras"},{"doc":"The Client module can be initialized manually (as shown in previous tutorials) or by overwriting configuration/1 and monitored_items/1 callbacks to auto-set the configuration and subscription items. It also helps you handle the Client's &quot;subscription&quot; events (monitorItems) by overwriting handle_subscription/2 callback. Like the Server module, the Client module is also based on a GenServer behavior. Therefore it accepts the same options for supervision to configure the child spec and passes them along to GenServer ; to add the Client behavior to your application, use the following code: use OpcUA.Client , restart : :transient , shutdown : 10_000 The basic callback is the init/2 that let you maniplulate the OPC UA client by given its PID (opc_ua_server_pid) with some user data (user_init_state): # Use the `init` function to configure your client. def init ( { parent_pid , 103 } = _user_init_state , opc_ua_client_pid ) do # this will be your app state %{ parent_pid : parent_pid , opc_ua_client_pid : opc_ua_client_pid } end Client Configuration The first executed optional callback is configuration/1 , it gets and execute the Client configuration and handles server connection parameters as follows: def configuration ( _user_init_state ) do { :ok , localhost } = :inet . gethostname ( ) [ config : [ set_config : %{ &quot;requestedSessionTimeout&quot; =&gt; 1200000 , &quot;secureChannelLifeTime&quot; =&gt; 600000 , &quot;timeout&quot; =&gt; 50000 } ] , conn : [ by_username : [ url : &quot;opc.tcp:// \#{ localhost } :4041/&quot; , user : &quot;alde103&quot; , password : &quot;secret&quot; ] ] ] end In this example, the client will use a predefined timeout and connection (url, user, etc.) parameters. The user_init_state is propagated to this callback too. Note : The output of these callbacks must be a list (type config_options) as shown in the Client module. Monitored Item The next optional callback to be executed is monitored_items/1 . It gets and adds all nodes (namespaces, object nodes, variable nodes, monitored items) to the Server, for example: def monitored_items ( _user_init_state ) do [ subscription : 200.0 , monitored_item : OpcUA.MonitoredItem . new ( [ monitored_item : NodeId . new ( ns_index : 2 , identifier_type : &quot;string&quot; , identifier : &quot;R1_TS1_Temperature&quot; ) , sampling_time : 100.0 , subscription_id : 1 ] ) ] end In this example, the client automatically sends a subscription request (with a publishing interval of 200.0 ms) and a monitored item request ( R1_TS1_Temperature ), the user_init_state is propagated to this callback too. Note : The output of these callbacks must be a list (type address_space_list) as shown in the Client module. An runtime callback is handle_monitored_data/2 , it handles every Server events triggered by a monitored item data, as follows: def handle_monitored_data ( monitored_item_event , state ) do # Do something with the event ({subscription_id, monitored_id, value} = monitored_item_event) # and your module state (state) state end Another runtime callback is handle_deleted_monitored_item/2 , it handles the withdrawal events of monitored items from the server, for example: def handle_deleted_monitored_item ( subscription_id , monitored_id , state ) do # Do something with this event ({subscription_id, monitored_id, value} = monitored_item_event) # and your module state (state) state end Subscription The library automatically creates subscriptions. However, there are some callbacks to handle unexpected events, as shown below: def handle_subscription_timeout ( subscription_id , state ) do # Do something with this event (subscription_id is an integer) # and your module state (state) state end The handle_deleted_subscription/2 handles the withdrawal events of subscriptions from the server, for example: def handle_deleted_subscription ( subscription_id , state ) do # Do something with this event (subscription_id is an integer) # and your module state (state) state end Example The following example shows a module that takes its configuration from the environment and notifies any client event to its parent process: defmodule MyClient do use OpcUA.Client alias OpcUA.Client # Use the `init` function to configure your Client. def init ( { parent_pid , 103 } = _user_init_state , opc_ua_client_pid ) do %{ parent_pid : parent_pid , opc_ua_client_pid : opc_ua_client_pid } end def configuration ( _user_init_state ) , do : Application . get_env ( :my_client , :configuration , [ ] ) def monitored_items ( _user_init_state ) , do : Application . get_env ( :my_client , :monitored_items , [ ] ) def handle_subscription_timeout ( subscription_id , state ) do send ( state . parent_pid , { :subscription_timeout , subscription_id } ) state end def handle_deleted_subscription ( subscription_id , state ) do send ( state . parent_pid , { :subscription_delete , subscription_id } ) state end def handle_monitored_data ( changed_data_event , state ) do send ( state . parent_pid , { :value_changed , changed_data_event } ) state end def handle_deleted_monitored_item ( subscription_id , monitored_id , state ) do send ( state . parent_pid , { :item_deleted , { subscription_id , monitored_id } } ) state end def read_node_value ( pid , node ) , do : GenServer . call ( pid , { :read , node } , :infinity ) def get_client ( pid ) , do : GenServer . call ( pid , { :get_client , nil } ) def handle_call ( { :read , node } , _from , state ) do resp = Client . read_node_value ( state . opc_ua_client_pid , node ) { :reply , resp , state } end def handle_call ( { :get_client , nil } , _from , state ) do { :reply , state . opc_ua_client_pid , state } end end This code can be executed as { :ok , c_pid } = MyClient . start_link ( { self ( ) , 103 } ) More examples can be found in the source code tests .","ref":"elixir-integration.html#client","title":"Elixir Integration - Client","type":"extras"}]